diff --git a/gdb/ChangeLog b/gdb/ChangeLog
index 67cc7dd..fb3f593 100644
--- a/gdb/ChangeLog
+++ b/gdb/ChangeLog
@@ -1,3 +1,38 @@
+2014-03-14  Pedro Alves  <palves@redhat.com>
+
+	* inferior.h (terminal_ours_for_output): Rename to ...
+	(child_terminal_ours_for_output): ... this.
+	(terminal_save_ours): Rename to ...
+	(child_terminal_save_ours): ... this.
+	(terminal_ours): Rename to ...
+	(child_terminal_ours): ... this.
+	(terminal_inferior): Rename to ...
+	(child_terminal_inferior): ... this.
+	(terminal_init_inferior): Rename to ...
+	(child_terminal_init_inferior): ... this.
+	(terminal_init_inferior_with_pgrp): Rename to ...
+	(child_terminal_init_inferior_with_pgrp): ... this.
+	* inflow.c (terminal_init_inferior_with_pgrp): Rename to ...
+	(child_terminal_init_with_pgrp): ... this.
+	(terminal_save_ours): Rename to ...
+	(child_terminal_save_ours): ... this.
+	(terminal_init_inferior): Rename to ...
+	(child_terminal_init): ... this.  Adjust.
+	(terminal_inferior): Rename to ...
+	(child_terminal_inferior): ... this.
+	(terminal_ours_for_output): Rename to ...
+	(child_terminal_ours_for_output): ... this.  Adjust.
+	(terminal_ours): Rename to ...
+	(child_terminal_ours): ... this.
+	(terminal_ours_1): Rename to ...
+	(child_terminal_ours_1): ... this.  Adjust.
+	* linux-nat.c (linux_nat_terminal_inferior): Adjust.
+	* windows-nat.c (do_initial_windows_stuff): Adjust.
+	* gnu-nat.c (gnu_terminal_init_inferior): Rename to ...
+	(gnu_terminal_init): ... this.  Adjust.
+	(gnu_target): Adjust.
+	* inf-child.c (inf_child_target): Adjust.
+
 2014-03-13  Doug Evans  <xdje42@gmail.com>
 
 	PR guile/16612
diff --git a/gdb/gnu-nat.c b/gdb/gnu-nat.c
index 296c162..aaccb5a 100644
--- a/gdb/gnu-nat.c
+++ b/gdb/gnu-nat.c
@@ -2257,10 +2257,10 @@ gnu_detach (struct target_ops *ops, const char *args, int from_tty)
 }
 
 static void
-gnu_terminal_init_inferior (struct target_ops *self)
+gnu_terminal_init (struct target_ops *self)
 {
   gdb_assert (gnu_current_inf);
-  terminal_init_inferior_with_pgrp (gnu_current_inf->pid);
+  child_terminal_init_with_pgrp (gnu_current_inf->pid);
 }
 
 static void
@@ -2676,7 +2676,7 @@ gnu_target (void)
   t->to_wait = gnu_wait;
   t->to_xfer_partial = gnu_xfer_partial;
   t->to_find_memory_regions = gnu_find_memory_regions;
-  t->to_terminal_init = gnu_terminal_init_inferior;
+  t->to_terminal_init = gnu_terminal_init;
   t->to_kill = gnu_kill_inferior;
   t->to_create_inferior = gnu_create_inferior;
   t->to_mourn_inferior = gnu_mourn_inferior;
diff --git a/gdb/inf-child.c b/gdb/inf-child.c
index cc16b40..282467b 100644
--- a/gdb/inf-child.c
+++ b/gdb/inf-child.c
@@ -416,11 +416,11 @@ inf_child_target (void)
   t->to_prepare_to_store = inf_child_prepare_to_store;
   t->to_insert_breakpoint = memory_insert_breakpoint;
   t->to_remove_breakpoint = memory_remove_breakpoint;
-  t->to_terminal_init = terminal_init_inferior;
-  t->to_terminal_inferior = terminal_inferior;
-  t->to_terminal_ours_for_output = terminal_ours_for_output;
-  t->to_terminal_save_ours = terminal_save_ours;
-  t->to_terminal_ours = terminal_ours;
+  t->to_terminal_init = child_terminal_init;
+  t->to_terminal_inferior = child_terminal_inferior;
+  t->to_terminal_ours_for_output = child_terminal_ours_for_output;
+  t->to_terminal_save_ours = child_terminal_save_ours;
+  t->to_terminal_ours = child_terminal_ours;
   t->to_terminal_info = child_terminal_info;
   t->to_post_startup_inferior = inf_child_post_startup_inferior;
   t->to_follow_fork = inf_child_follow_fork;
diff --git a/gdb/inferior.h b/gdb/inferior.h
index 9f6375e..6c0730a 100644
--- a/gdb/inferior.h
+++ b/gdb/inferior.h
@@ -115,10 +115,6 @@ extern int disable_randomization;
 
 extern void generic_mourn_inferior (void);
 
-extern void terminal_save_ours (struct target_ops *self);
-
-extern void terminal_ours (struct target_ops *self);
-
 extern CORE_ADDR unsigned_pointer_to_address (struct gdbarch *gdbarch,
 					      struct type *type,
 					      const gdb_byte *buf);
@@ -164,13 +160,17 @@ extern void child_terminal_info (struct target_ops *self, const char *, int);
 
 extern void term_info (char *, int);
 
-extern void terminal_ours_for_output (struct target_ops *self);
+extern void child_terminal_save_ours (struct target_ops *self);
+
+extern void child_terminal_ours (struct target_ops *self);
+
+extern void child_terminal_ours_for_output (struct target_ops *self);
 
-extern void terminal_inferior (struct target_ops *self);
+extern void child_terminal_inferior (struct target_ops *self);
 
-extern void terminal_init_inferior (struct target_ops *self);
+extern void child_terminal_init (struct target_ops *self);
 
-extern void terminal_init_inferior_with_pgrp (int pgrp);
+extern void child_terminal_init_with_pgrp (int pgrp);
 
 /* From fork-child.c */
 
diff --git a/gdb/inflow.c b/gdb/inflow.c
index 09623ab..5f81de2 100644
--- a/gdb/inflow.c
+++ b/gdb/inflow.c
@@ -46,7 +46,7 @@ extern void _initialize_inflow (void);
 
 static void pass_signal (int);
 
-static void terminal_ours_1 (int);
+static void child_terminal_ours_1 (int);
 
 /* Record terminal status separately for debugger and inferior.  */
 
@@ -209,13 +209,11 @@ gdb_has_a_terminal (void)
     fprintf_unfiltered(gdb_stderr, "[%s failed in terminal_inferior: %s]\n", \
 	    what, safe_strerror (errno))
 
-static void terminal_ours_1 (int);
-
 /* Initialize the terminal settings we record for the inferior,
    before we actually run the inferior.  */
 
 void
-terminal_init_inferior_with_pgrp (int pgrp)
+child_terminal_init_with_pgrp (int pgrp)
 {
   struct inferior *inf = current_inferior ();
   struct terminal_info *tinfo = get_inflow_inferior_data (inf);
@@ -245,7 +243,7 @@ terminal_init_inferior_with_pgrp (int pgrp)
    and gdb must be able to restore it correctly.  */
 
 void
-terminal_save_ours (struct target_ops *self)
+child_terminal_save_ours (struct target_ops *self)
 {
   if (gdb_has_a_terminal ())
     {
@@ -255,16 +253,16 @@ terminal_save_ours (struct target_ops *self)
 }
 
 void
-terminal_init_inferior (struct target_ops *self)
+child_terminal_init (struct target_ops *self)
 {
 #ifdef PROCESS_GROUP_TYPE
-  /* This is for Lynx, and should be cleaned up by having Lynx be a separate
-     debugging target with a version of target_terminal_init_inferior which
-     passes in the process group to a generic routine which does all the work
-     (and the non-threaded child_terminal_init_inferior can just pass in
-     inferior_ptid to the same routine).  */
+  /* This is for Lynx, and should be cleaned up by having Lynx be a
+     separate debugging target with a version of target_terminal_init
+     which passes in the process group to a generic routine which does
+     all the work (and the non-threaded child_terminal_init can just
+     pass in inferior_ptid to the same routine).  */
   /* We assume INFERIOR_PID is also the child's process group.  */
-  terminal_init_inferior_with_pgrp (ptid_get_pid (inferior_ptid));
+  child_terminal_init_with_pgrp (ptid_get_pid (inferior_ptid));
 #endif /* PROCESS_GROUP_TYPE */
 }
 
@@ -272,7 +270,7 @@ terminal_init_inferior (struct target_ops *self)
    This is preparation for starting or resuming the inferior.  */
 
 void
-terminal_inferior (struct target_ops *self)
+child_terminal_inferior (struct target_ops *self)
 {
   struct inferior *inf;
   struct terminal_info *tinfo;
@@ -353,9 +351,9 @@ terminal_inferior (struct target_ops *self)
    should be called to get back to a normal state of affairs.  */
 
 void
-terminal_ours_for_output (struct target_ops *self)
+child_terminal_ours_for_output (struct target_ops *self)
 {
-  terminal_ours_1 (1);
+  child_terminal_ours_1 (1);
 }
 
 /* Put our terminal settings into effect.
@@ -363,9 +361,9 @@ terminal_ours_for_output (struct target_ops *self)
    so they can be restored properly later.  */
 
 void
-terminal_ours (struct target_ops *self)
+child_terminal_ours (struct target_ops *self)
 {
-  terminal_ours_1 (0);
+  child_terminal_ours_1 (0);
 }
 
 /* output_only is not used, and should not be used unless we introduce
@@ -373,7 +371,7 @@ terminal_ours (struct target_ops *self)
    flags.  */
 
 static void
-terminal_ours_1 (int output_only)
+child_terminal_ours_1 (int output_only)
 {
   struct inferior *inf;
   struct terminal_info *tinfo;
@@ -446,7 +444,7 @@ terminal_ours_1 (int output_only)
 	     such situations as well.  */
 	  if (result == -1)
 	    fprintf_unfiltered (gdb_stderr,
-				"[tcsetpgrp failed in terminal_ours: %s]\n",
+				"[tcsetpgrp failed in child_terminal_ours: %s]\n",
 				safe_strerror (errno));
 #endif
 #endif /* termios */
diff --git a/gdb/linux-nat.c b/gdb/linux-nat.c
index 5535462..b615423 100644
--- a/gdb/linux-nat.c
+++ b/gdb/linux-nat.c
@@ -4568,11 +4568,11 @@ linux_nat_terminal_inferior (struct target_ops *self)
   if (!target_is_async_p ())
     {
       /* Async mode is disabled.  */
-      terminal_inferior (self);
+      child_terminal_inferior (self);
       return;
     }
 
-  terminal_inferior (self);
+  child_terminal_inferior (self);
 
   /* Calls to target_terminal_*() are meant to be idempotent.  */
   if (!async_terminal_is_ours)
@@ -4591,14 +4591,14 @@ linux_nat_terminal_ours (struct target_ops *self)
   if (!target_is_async_p ())
     {
       /* Async mode is disabled.  */
-      terminal_ours (self);
+      child_terminal_ours (self);
       return;
     }
 
   /* GDB should never give the terminal to the inferior if the
      inferior is running in the background (run&, continue&, etc.),
      but claiming it sure should.  */
-  terminal_ours (self);
+  child_terminal_ours (self);
 
   if (async_terminal_is_ours)
     return;
diff --git a/gdb/windows-nat.c b/gdb/windows-nat.c
index 6e62dfe..fe40c4d 100644
--- a/gdb/windows-nat.c
+++ b/gdb/windows-nat.c
@@ -1725,7 +1725,7 @@ do_initial_windows_stuff (struct target_ops *ops, DWORD pid, int attaching)
      current thread until we report an event out of windows_wait.  */
   inferior_ptid = pid_to_ptid (pid);
 
-  terminal_init_inferior_with_pgrp (pid);
+  child_terminal_init_with_pgrp (pid);
   target_terminal_inferior ();
 
   windows_initialization_done = 0;