diff --git a/gdb/ChangeLog b/gdb/ChangeLog
index c1231ca..74e20a4 100644
--- a/gdb/ChangeLog
+++ b/gdb/ChangeLog
@@ -1,3 +1,8 @@
+2014-03-25  Pedro Alves  <palves@redhat.com>
+
+	* cli/cli-script.c (script_from_file): Force the interpreter to
+	sync mode.
+
 2014-03-24  Pierre Langlois  <pierre.langlois@embecosm.com>
 
 	* avr-tdep.c (avr_scan_prologue): Accept push r1 instruction for
diff --git a/gdb/cli/cli-script.c b/gdb/cli/cli-script.c
index 246fcc9..7dc1ba4 100644
--- a/gdb/cli/cli-script.c
+++ b/gdb/cli/cli-script.c
@@ -1667,6 +1667,9 @@ script_from_file (FILE *stream, const char *file)
   source_line_number = 0;
   source_file_name = file;
 
+  make_cleanup_restore_integer (&interpreter_async);
+  interpreter_async = 0;
+
   {
     volatile struct gdb_exception e;
 
diff --git a/gdb/testsuite/ChangeLog b/gdb/testsuite/ChangeLog
index ba0471a..b7bc990 100644
--- a/gdb/testsuite/ChangeLog
+++ b/gdb/testsuite/ChangeLog
@@ -1,3 +1,10 @@
+2014-03-25  Pedro Alves  <palves@redhat.com>
+	    Doug Evans  <dje@google.com>
+
+	* gdb.base/source-execution.c: New file.
+	* gdb.base/source-execution.exp: New file.
+	* gdb.base/source-execution.gdb: New file.
+
 2014-03-24  Doug Evans  <dje@google.com>
 
 	* gdb.linespec/macro-relative.exp: Mark the test as unsupported if
diff --git a/gdb/testsuite/gdb.base/source-execution.c b/gdb/testsuite/gdb.base/source-execution.c
new file mode 100644
index 0000000..e7de119
--- /dev/null
+++ b/gdb/testsuite/gdb.base/source-execution.c
@@ -0,0 +1,41 @@
+/* This testcase is part of GDB, the GNU debugger.
+
+   Copyright 2014 Free Software Foundation, Inc.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
+
+static void
+func1 (void)
+{
+}
+
+static void
+func2 (void)
+{
+}
+
+static void
+func3 (void)
+{
+}
+
+int
+main (void)
+{
+  func1 ();
+  func2 ();
+  func3 ();
+
+  return 0;
+}
diff --git a/gdb/testsuite/gdb.base/source-execution.exp b/gdb/testsuite/gdb.base/source-execution.exp
new file mode 100644
index 0000000..0b0e8ef
--- /dev/null
+++ b/gdb/testsuite/gdb.base/source-execution.exp
@@ -0,0 +1,33 @@
+# This testcase is part of GDB, the GNU debugger.
+
+# Copyright 2014 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+# Test sourcing a script that runs execution commands.
+
+standard_testfile
+
+if {[prepare_for_testing "failed to prepare" $testfile $srcfile debug]} {
+    return -1
+}
+
+if ![runto_main] then {
+    fail "Can't run to main"
+    return 0
+}
+
+gdb_test "source ${srcdir}/${subdir}/source-execution.gdb" \
+    "func2.*func3.*" \
+    "source source-execution.gdb"
diff --git a/gdb/testsuite/gdb.base/source-execution.gdb b/gdb/testsuite/gdb.base/source-execution.gdb
new file mode 100644
index 0000000..6a08f56
--- /dev/null
+++ b/gdb/testsuite/gdb.base/source-execution.gdb
@@ -0,0 +1,21 @@
+# This testcase is part of GDB, the GNU debugger.
+#
+# Copyright 2014 Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+# A couple synchronous execution commands in succession, to make sure
+# GDB waits for the first to complete before moving to the second.
+next
+next