diff --git a/gdb/ChangeLog b/gdb/ChangeLog
index ee620d0..147022c 100644
--- a/gdb/ChangeLog
+++ b/gdb/ChangeLog
@@ -1,3 +1,40 @@
+2014-06-20  Gary Benson  <gbenson@redhat.com>
+
+	* common/gdb_thread_db.h: Moved to nat.  All includes updated.
+	* common/glibc_thread_db.h: Likewise.
+	* common/i386-cpuid.h: Likewise.
+	* common/i386-gcc-cpuid.h: Likewise.
+	* common/i386-xstate.h: Likewise.
+	* common/linux-btrace.h: Likewise.
+	* common/linux-osdata.h: Likewise.
+	* common/linux-procfs.h: Likewise.
+	* common/linux-ptrace.h: Likewise.
+	* common/mips-linux-watch.h: Likewise.
+	* common/linux-btrace.c: Moved to nat.
+	* common/linux-osdata.c: Likewise.
+	* common/linux-procfs.c: Likewise.
+	* common/linux-ptrace.c: Likewise.
+	* common/mips-linux-watch.c: Likewise.
+	* nat/gdb_thread_db.h: Moved from common.
+	* nat/glibc_thread_db.h: Likewise.
+	* nat/i386-cpuid.h: Likewise.
+	* nat/i386-gcc-cpuid.h: Likewise.
+	* nat/i386-xstate.h: Likewise.
+	* nat/linux-btrace.c: Likewise.
+	* nat/linux-btrace.h: Likewise.
+	* nat/linux-osdata.c: Likewise.
+	* nat/linux-osdata.h: Likewise.
+	* nat/linux-procfs.c: Likewise.
+	* nat/linux-procfs.h: Likewise.
+	* nat/linux-ptrace.c: Likewise.
+	* nat/linux-ptrace.h: Likewise.
+	* nat/mips-linux-watch.c: Likewise.
+	* nat/mips-linux-watch.h: Likewise.
+	* Makefile.in (HFILES_NO_SRCDIR): Reflect new locations.
+	(object file files): Reordered.
+	* gdb/copyright.py (EXCLUDE_LIST): Reflect new location
+	of glibc_thread_db.h.
+
 2014-06-19  Yao Qi  <yao@codesourcery.com>
 
 	* gdbthread.h (any_running): Remove the declaration.
diff --git a/gdb/gdbserver/ChangeLog b/gdb/gdbserver/ChangeLog
index dda84f9..91790ee 100644
--- a/gdb/gdbserver/ChangeLog
+++ b/gdb/gdbserver/ChangeLog
@@ -1,3 +1,9 @@
+2014-06-20  Gary Benson  <gbenson@redhat.com>
+
+	* Makefile.in (SFILES): Update locations for files moved
+	from common to nat.
+	(object file files): Reordered.
+
 2014-06-19  Gary Benson  <gbenson@redhat.com>
 
 	* Makefile.in (i386-dregs.o): New rule.
diff --git a/gdb/testsuite/ChangeLog b/gdb/testsuite/ChangeLog
index af37409..2c3307a 100644
--- a/gdb/testsuite/ChangeLog
+++ b/gdb/testsuite/ChangeLog
@@ -1,3 +1,8 @@
+2014-06-20  Gary Benson  <gbenson@redhat.com>
+
+	* gdb.arch/i386-avx.exp: Fix include file location.
+	* gdb.arch/i386-sse.exp: Likewise.
+
 2014-06-19  Pedro Alves  <palves@redhat.com>
 
 	* gdb.threads/thread-execl.exp (do_test): New procedure, factored
diff --git a/gdb/Makefile.in b/gdb/Makefile.in
index f4dd406..8142477 100644
--- a/gdb/Makefile.in
+++ b/gdb/Makefile.in
@@ -861,8 +861,8 @@ LINTFILES = $(SFILES) $(YYFILES) $(CONFIG_SRCS) init.c
 # right, it is probably easiest just to list .h files here directly.
 
 HFILES_NO_SRCDIR = \
-common/gdb_signals.h common/gdb_thread_db.h common/gdb_vecs.h \
-common/i386-xstate.h common/linux-ptrace.h common/mips-linux-watch.h \
+common/gdb_signals.h nat/gdb_thread_db.h common/gdb_vecs.h \
+nat/i386-xstate.h nat/linux-ptrace.h nat/mips-linux-watch.h \
 proc-utils.h aarch64-tdep.h arm-tdep.h ax-gdb.h ppcfbsd-tdep.h \
 ppcnbsd-tdep.h cli-out.h gdb_expat.h breakpoint.h infcall.h obsd-tdep.h \
 exec.h m32r-tdep.h osabi.h gdbcore.h solib-som.h amd64bsd-nat.h \
@@ -930,9 +930,9 @@ gnulib/import/extra/snippet/warn-on-use.h \
 gnulib/import/stddef.in.h gnulib/import/inttypes.in.h inline-frame.h skip.h \
 common/common-utils.h common/xml-utils.h common/buffer.h common/ptid.h \
 common/format.h common/host-defs.h utils.h common/queue.h \
-common/linux-osdata.h gdb-dlfcn.h auto-load.h probe.h stap-probe.h \
-gdb_bfd.h sparc-ravenscar-thread.h ppc-ravenscar-thread.h common/linux-btrace.h \
-ctf.h common/i386-cpuid.h common/i386-gcc-cpuid.h target/resume.h \
+nat/linux-osdata.h gdb-dlfcn.h auto-load.h probe.h stap-probe.h \
+gdb_bfd.h sparc-ravenscar-thread.h ppc-ravenscar-thread.h nat/linux-btrace.h \
+ctf.h nat/i386-cpuid.h nat/i386-gcc-cpuid.h target/resume.h \
 target/wait.h target/waitstatus.h nat/linux-nat.h nat/linux-waitpid.h \
 common/print-utils.h common/rsp-low.h nat/i386-dregs.h
 
@@ -2127,18 +2127,6 @@ format.o: ${srcdir}/common/format.c
 	$(COMPILE) $(srcdir)/common/format.c
 	$(POSTCOMPILE)
 
-linux-osdata.o: ${srcdir}/common/linux-osdata.c
-	$(COMPILE) $(srcdir)/common/linux-osdata.c
-	$(POSTCOMPILE)
-
-linux-procfs.o: $(srcdir)/common/linux-procfs.c
-	$(COMPILE) $(srcdir)/common/linux-procfs.c
-	$(POSTCOMPILE)
-
-linux-ptrace.o: $(srcdir)/common/linux-ptrace.c
-	$(COMPILE) $(srcdir)/common/linux-ptrace.c
-	$(POSTCOMPILE)
-
 common-agent.o: $(srcdir)/common/agent.c
 	$(COMPILE) $(srcdir)/common/agent.c
 	$(POSTCOMPILE)
@@ -2147,14 +2135,6 @@ vec.o: ${srcdir}/common/vec.c
 	$(COMPILE) $(srcdir)/common/vec.c
 	$(POSTCOMPILE)
 
-linux-btrace.o: ${srcdir}/common/linux-btrace.c
-	$(COMPILE) $(srcdir)/common/linux-btrace.c
-	$(POSTCOMPILE)
-
-mips-linux-watch.o: ${srcdir}/common/mips-linux-watch.c
-	$(COMPILE) $(srcdir)/common/mips-linux-watch.c
-	$(POSTCOMPILE)
-
 print-utils.o: ${srcdir}/common/print-utils.c
 	$(COMPILE) $(srcdir)/common/print-utils.c
 	$(POSTCOMPILE)
@@ -2182,10 +2162,30 @@ i386-dregs.o: ${srcdir}/nat/i386-dregs.c
 	$(COMPILE) $(srcdir)/nat/i386-dregs.c
 	$(POSTCOMPILE)
 
+linux-btrace.o: ${srcdir}/nat/linux-btrace.c
+	$(COMPILE) $(srcdir)/nat/linux-btrace.c
+	$(POSTCOMPILE)
+
+linux-osdata.o: ${srcdir}/nat/linux-osdata.c
+	$(COMPILE) $(srcdir)/nat/linux-osdata.c
+	$(POSTCOMPILE)
+
+linux-procfs.o: $(srcdir)/nat/linux-procfs.c
+	$(COMPILE) $(srcdir)/nat/linux-procfs.c
+	$(POSTCOMPILE)
+
+linux-ptrace.o: $(srcdir)/nat/linux-ptrace.c
+	$(COMPILE) $(srcdir)/nat/linux-ptrace.c
+	$(POSTCOMPILE)
+
 linux-waitpid.o: ${srcdir}/nat/linux-waitpid.c
 	$(COMPILE) $(srcdir)/nat/linux-waitpid.c
 	$(POSTCOMPILE)
 
+mips-linux-watch.o: ${srcdir}/nat/mips-linux-watch.c
+	$(COMPILE) $(srcdir)/nat/mips-linux-watch.c
+	$(POSTCOMPILE)
+
 #
 # gdb/tui/ dependencies
 #
diff --git a/gdb/amd64-linux-nat.c b/gdb/amd64-linux-nat.c
index 06199af..7522231 100644
--- a/gdb/amd64-linux-nat.c
+++ b/gdb/amd64-linux-nat.c
@@ -25,7 +25,7 @@
 #include "regset.h"
 #include "linux-nat.h"
 #include "amd64-linux-tdep.h"
-#include "linux-btrace.h"
+#include "nat/linux-btrace.h"
 #include "btrace.h"
 
 #include "gdb_assert.h"
@@ -56,7 +56,7 @@
 #include "i386-linux-tdep.h"
 #include "amd64-nat.h"
 #include "i386-nat.h"
-#include "i386-xstate.h"
+#include "nat/i386-xstate.h"
 
 #ifndef PTRACE_GETREGSET
 #define PTRACE_GETREGSET	0x4204
diff --git a/gdb/amd64-linux-tdep.c b/gdb/amd64-linux-tdep.c
index 9699c12..76cd099 100644
--- a/gdb/amd64-linux-tdep.c
+++ b/gdb/amd64-linux-tdep.c
@@ -31,7 +31,7 @@
 #include "amd64-linux-tdep.h"
 #include "i386-linux-tdep.h"
 #include "linux-tdep.h"
-#include "i386-xstate.h"
+#include "nat/i386-xstate.h"
 
 #include <string.h>
 
diff --git a/gdb/copyright.py b/gdb/copyright.py
index 43fc455..352abff 100644
--- a/gdb/copyright.py
+++ b/gdb/copyright.py
@@ -171,7 +171,7 @@ def main ():
 #
 # Filenames are relative to the root directory.
 EXCLUDE_LIST = (
-    'gdb/common/glibc_thread_db.h',
+    'gdb/nat/glibc_thread_db.h',
     'gdb/CONTRIBUTE',
     'gdb/gnulib/import'
 )
diff --git a/gdb/gdbserver/Makefile.in b/gdb/gdbserver/Makefile.in
index 76d8965..a86ef58 100644
--- a/gdb/gdbserver/Makefile.in
+++ b/gdb/gdbserver/Makefile.in
@@ -163,10 +163,10 @@ SFILES=	$(srcdir)/gdbreplay.c $(srcdir)/inferiors.c $(srcdir)/dll.c \
 	$(srcdir)/hostio.c $(srcdir)/hostio-errno.c \
 	$(srcdir)/common/vec.c $(srcdir)/common/gdb_vecs.c \
 	$(srcdir)/common/common-utils.c $(srcdir)/common/xml-utils.c \
-	$(srcdir)/common/linux-osdata.c $(srcdir)/common/ptid.c \
-	$(srcdir)/common/buffer.c $(srcdir)/common/linux-btrace.c \
+	$(srcdir)/nat/linux-osdata.c $(srcdir)/common/ptid.c \
+	$(srcdir)/common/buffer.c $(srcdir)/nat/linux-btrace.c \
 	$(srcdir)/common/filestuff.c $(srcdir)/target/waitstatus.c \
-	$(srcdir)/common/mips-linux-watch.c $(srcdir)/common/print-utils.c \
+	$(srcdir)/nat/mips-linux-watch.c $(srcdir)/common/print-utils.c \
 	$(srcdir)/common/rsp-low.c
 
 DEPFILES = @GDBSERVER_DEPFILES@
@@ -501,12 +501,6 @@ print-utils.o: ../common/print-utils.c
 rsp-low.o: ../common/rsp-low.c
 	$(COMPILE) $<
 	$(POSTCOMPILE)
-linux-procfs.o: ../common/linux-procfs.c
-	$(COMPILE) $<
-	$(POSTCOMPILE)
-linux-ptrace.o: ../common/linux-ptrace.c
-	$(COMPILE) $<
-	$(POSTCOMPILE)
 common-utils.o: ../common/common-utils.c
 	$(COMPILE) $<
 	$(POSTCOMPILE)
@@ -519,9 +513,6 @@ gdb_vecs.o: ../common/gdb_vecs.c
 xml-utils.o: ../common/xml-utils.c
 	$(COMPILE) $<
 	$(POSTCOMPILE)
-linux-osdata.o: ../common/linux-osdata.c
-	$(COMPILE) $<
-	$(POSTCOMPILE)
 ptid.o: ../common/ptid.c
 	$(COMPILE) $<
 	$(POSTCOMPILE)
@@ -541,23 +532,29 @@ waitstatus.o: ../target/waitstatus.c
 	$(COMPILE) $<
 	$(POSTCOMPILE)
 
-linux-btrace.o: ../common/linux-btrace.c
+# Native object files rules from ../nat
+
+i386-dregs.o: ../nat/i386-dregs.c
 	$(COMPILE) $<
 	$(POSTCOMPILE)
-
-mips-linux-watch.o: ../common/mips-linux-watch.c
+linux-btrace.o: ../nat/linux-btrace.c
 	$(COMPILE) $<
 	$(POSTCOMPILE)
-
-# Native object files rules from ../nat
-
-i386-dregs.o: ../nat/i386-dregs.c
+linux-osdata.o: ../nat/linux-osdata.c
+	$(COMPILE) $<
+	$(POSTCOMPILE)
+linux-procfs.o: ../nat/linux-procfs.c
+	$(COMPILE) $<
+	$(POSTCOMPILE)
+linux-ptrace.o: ../nat/linux-ptrace.c
 	$(COMPILE) $<
 	$(POSTCOMPILE)
-
 linux-waitpid.o: ../nat/linux-waitpid.c
 	$(COMPILE) $<
 	$(POSTCOMPILE)
+mips-linux-watch.o: ../nat/mips-linux-watch.c
+	$(COMPILE) $<
+	$(POSTCOMPILE)
 
 aarch64.c : $(srcdir)/../regformats/aarch64.dat $(regdat_sh)
 	$(SHELL) $(regdat_sh) $(srcdir)/../regformats/aarch64.dat aarch64.c
diff --git a/gdb/gdbserver/i387-fp.c b/gdb/gdbserver/i387-fp.c
index c2d0bdf..74240a2 100644
--- a/gdb/gdbserver/i387-fp.c
+++ b/gdb/gdbserver/i387-fp.c
@@ -18,7 +18,7 @@
 
 #include "server.h"
 #include "i387-fp.h"
-#include "i386-xstate.h"
+#include "nat/i386-xstate.h"
 
 static const int num_mpx_bnd_registers = 4;
 static const int num_mpx_cfg_registers = 2;
diff --git a/gdb/gdbserver/linux-low.c b/gdb/gdbserver/linux-low.c
index 1932ff2..61552f4 100644
--- a/gdb/gdbserver/linux-low.c
+++ b/gdb/gdbserver/linux-low.c
@@ -18,7 +18,7 @@
 
 #include "server.h"
 #include "linux-low.h"
-#include "linux-osdata.h"
+#include "nat/linux-osdata.h"
 #include "agent.h"
 
 #include "nat/linux-nat.h"
@@ -26,8 +26,8 @@
 #include "gdb_wait.h"
 #include <stdio.h>
 #include <sys/ptrace.h>
-#include "linux-ptrace.h"
-#include "linux-procfs.h"
+#include "nat/linux-ptrace.h"
+#include "nat/linux-procfs.h"
 #include <signal.h>
 #include <sys/ioctl.h>
 #include <fcntl.h>
@@ -105,7 +105,7 @@
 #endif
 
 #ifdef HAVE_LINUX_BTRACE
-# include "linux-btrace.h"
+# include "nat/linux-btrace.h"
 #endif
 
 #ifndef HAVE_ELF32_AUXV_T
diff --git a/gdb/gdbserver/linux-low.h b/gdb/gdbserver/linux-low.h
index 498b221..4820929 100644
--- a/gdb/gdbserver/linux-low.h
+++ b/gdb/gdbserver/linux-low.h
@@ -16,14 +16,14 @@
    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
 
-#include "gdb_thread_db.h"
+#include "nat/gdb_thread_db.h"
 #include <signal.h>
 
 #include "gdbthread.h"
 #include "gdb_proc_service.h"
 
 /* Included for ptrace type definitions.  */
-#include "linux-ptrace.h"
+#include "nat/linux-ptrace.h"
 
 #define PTRACE_XFER_TYPE long
 
diff --git a/gdb/gdbserver/linux-mips-low.c b/gdb/gdbserver/linux-mips-low.c
index 320e2b1..1b2160b 100644
--- a/gdb/gdbserver/linux-mips-low.c
+++ b/gdb/gdbserver/linux-mips-low.c
@@ -22,7 +22,7 @@
 #include <sys/ptrace.h>
 #include <endian.h>
 
-#include "mips-linux-watch.h"
+#include "nat/mips-linux-watch.h"
 #include "gdb_proc_service.h"
 
 /* Defined in auto-generated file mips-linux.c.  */
diff --git a/gdb/gdbserver/linux-x86-low.c b/gdb/gdbserver/linux-x86-low.c
index b8a0006..2a637f2 100644
--- a/gdb/gdbserver/linux-x86-low.c
+++ b/gdb/gdbserver/linux-x86-low.c
@@ -25,7 +25,7 @@
 #include "linux-low.h"
 #include "i387-fp.h"
 #include "i386-low.h"
-#include "i386-xstate.h"
+#include "nat/i386-xstate.h"
 
 #include "gdb_proc_service.h"
 /* Don't include elf/common.h if linux/elf.h got included by
diff --git a/gdb/gdbserver/thread-db.c b/gdb/gdbserver/thread-db.c
index 3ea0cc3..d69c9e4 100644
--- a/gdb/gdbserver/thread-db.c
+++ b/gdb/gdbserver/thread-db.c
@@ -27,7 +27,7 @@ extern int debug_threads;
 static int thread_db_use_events;
 
 #include "gdb_proc_service.h"
-#include "gdb_thread_db.h"
+#include "nat/gdb_thread_db.h"
 #include "gdb_vecs.h"
 
 #ifndef USE_LIBTHREAD_DB_DIRECTLY
diff --git a/gdb/go32-nat.c b/gdb/go32-nat.c
index 89157d3..27938cc 100644
--- a/gdb/go32-nat.c
+++ b/gdb/go32-nat.c
@@ -97,7 +97,7 @@
 #include "buildsym.h"
 #include "i387-tdep.h"
 #include "i386-tdep.h"
-#include "i386-cpuid.h"
+#include "nat/i386-cpuid.h"
 #include "value.h"
 #include "regcache.h"
 #include <string.h>
diff --git a/gdb/i386-linux-nat.c b/gdb/i386-linux-nat.c
index bb2b911..d4cb99b 100644
--- a/gdb/i386-linux-nat.c
+++ b/gdb/i386-linux-nat.c
@@ -25,7 +25,7 @@
 #include "regset.h"
 #include "target.h"
 #include "linux-nat.h"
-#include "linux-btrace.h"
+#include "nat/linux-btrace.h"
 #include "btrace.h"
 
 #include "gdb_assert.h"
@@ -58,7 +58,7 @@
 /* Defines ps_err_e, struct ps_prochandle.  */
 #include "gdb_proc_service.h"
 
-#include "i386-xstate.h"
+#include "nat/i386-xstate.h"
 
 #ifndef PTRACE_GETREGSET
 #define PTRACE_GETREGSET	0x4204
diff --git a/gdb/i386-linux-tdep.c b/gdb/i386-linux-tdep.c
index 8ab8954..be7a886 100644
--- a/gdb/i386-linux-tdep.c
+++ b/gdb/i386-linux-tdep.c
@@ -39,7 +39,7 @@
 #include "xml-syscall.h"
 
 #include "i387-tdep.h"
-#include "i386-xstate.h"
+#include "nat/i386-xstate.h"
 
 /* The syscall's XML filename for i386.  */
 #define XML_SYSCALL_FILENAME_I386 "syscalls/i386-linux.xml"
diff --git a/gdb/i386-tdep.c b/gdb/i386-tdep.c
index 5e3cc79..4c65ac5 100644
--- a/gdb/i386-tdep.c
+++ b/gdb/i386-tdep.c
@@ -50,7 +50,7 @@
 
 #include "i386-tdep.h"
 #include "i387-tdep.h"
-#include "i386-xstate.h"
+#include "nat/i386-xstate.h"
 
 #include "record.h"
 #include "record-full.h"
diff --git a/gdb/i387-tdep.c b/gdb/i387-tdep.c
index c58a000..5b2c025 100644
--- a/gdb/i387-tdep.c
+++ b/gdb/i387-tdep.c
@@ -32,7 +32,7 @@
 
 #include "i386-tdep.h"
 #include "i387-tdep.h"
-#include "i386-xstate.h"
+#include "nat/i386-xstate.h"
 
 /* Print the floating point number specified by RAW.  */
 
diff --git a/gdb/linux-nat.c b/gdb/linux-nat.c
index c9677ca..0ab0362 100644
--- a/gdb/linux-nat.c
+++ b/gdb/linux-nat.c
@@ -32,8 +32,8 @@
 #endif
 #include <sys/ptrace.h>
 #include "linux-nat.h"
-#include "linux-ptrace.h"
-#include "linux-procfs.h"
+#include "nat/linux-ptrace.h"
+#include "nat/linux-procfs.h"
 #include "linux-fork.h"
 #include "gdbthread.h"
 #include "gdbcmd.h"
@@ -59,7 +59,7 @@
 #include "terminal.h"
 #include <sys/vfs.h>
 #include "solib.h"
-#include "linux-osdata.h"
+#include "nat/linux-osdata.h"
 #include "linux-tdep.h"
 #include "symfile.h"
 #include "agent.h"
diff --git a/gdb/linux-thread-db.c b/gdb/linux-thread-db.c
index c79d994..e693c65 100644
--- a/gdb/linux-thread-db.c
+++ b/gdb/linux-thread-db.c
@@ -22,7 +22,7 @@
 #include "gdb_assert.h"
 #include <dlfcn.h>
 #include "gdb_proc_service.h"
-#include "gdb_thread_db.h"
+#include "nat/gdb_thread_db.h"
 #include "gdb_vecs.h"
 #include "bfd.h"
 #include "command.h"
@@ -40,8 +40,8 @@
 #include "gdbcore.h"
 #include "observer.h"
 #include "linux-nat.h"
-#include "linux-procfs.h"
-#include "linux-osdata.h"
+#include "nat/linux-procfs.h"
+#include "nat/linux-osdata.h"
 #include "auto-load.h"
 #include "cli/cli-utils.h"
 
diff --git a/gdb/mips-linux-nat.c b/gdb/mips-linux-nat.c
index 5594e10..dbd7ae7 100644
--- a/gdb/mips-linux-nat.c
+++ b/gdb/mips-linux-nat.c
@@ -36,7 +36,7 @@
 #include <sys/ptrace.h>
 #include <asm/ptrace.h>
 
-#include "mips-linux-watch.h"
+#include "nat/mips-linux-watch.h"
 
 #include "features/mips-linux.c"
 #include "features/mips-dsp-linux.c"
diff --git a/gdb/common/gdb_thread_db.h b/gdb/nat/gdb_thread_db.h
similarity index 92%
rename from gdb/common/gdb_thread_db.h
rename to gdb/nat/gdb_thread_db.h
index a1d9473..6a9d6f2 100644
--- a/gdb/common/gdb_thread_db.h
+++ b/gdb/nat/gdb_thread_db.h
@@ -1,7 +1,7 @@
 #ifdef HAVE_THREAD_DB_H
 #include <thread_db.h>
 #else
-#include "glibc_thread_db.h"
+#include "nat/glibc_thread_db.h"
 #endif
 
 #ifndef LIBTHREAD_DB_SO
diff --git a/gdb/common/glibc_thread_db.h b/gdb/nat/glibc_thread_db.h
similarity index 100%
rename from gdb/common/glibc_thread_db.h
rename to gdb/nat/glibc_thread_db.h
diff --git a/gdb/common/i386-cpuid.h b/gdb/nat/i386-cpuid.h
similarity index 98%
rename from gdb/common/i386-cpuid.h
rename to gdb/nat/i386-cpuid.h
index 9aea054..1067f66 100644
--- a/gdb/common/i386-cpuid.h
+++ b/gdb/nat/i386-cpuid.h
@@ -20,7 +20,7 @@
 #define I386_CPUID_COMMON_H
 
 /* Always include the header for the cpu bit defines.  */
-#include "i386-gcc-cpuid.h"
+#include "nat/i386-gcc-cpuid.h"
 
 #if defined(__i386__) || defined(__x86_64__)
 
diff --git a/gdb/common/i386-gcc-cpuid.h b/gdb/nat/i386-gcc-cpuid.h
similarity index 100%
rename from gdb/common/i386-gcc-cpuid.h
rename to gdb/nat/i386-gcc-cpuid.h
diff --git a/gdb/common/i386-xstate.h b/gdb/nat/i386-xstate.h
similarity index 100%
rename from gdb/common/i386-xstate.h
rename to gdb/nat/i386-xstate.h
diff --git a/gdb/common/linux-btrace.c b/gdb/nat/linux-btrace.c
similarity index 99%
rename from gdb/common/linux-btrace.c
rename to gdb/nat/linux-btrace.c
index 188220b..5701aaf 100644
--- a/gdb/common/linux-btrace.c
+++ b/gdb/nat/linux-btrace.c
@@ -25,13 +25,13 @@
 #include "defs.h"
 #endif
 
-#include "linux-btrace.h"
+#include "nat/linux-btrace.h"
 #include "common-utils.h"
 #include "gdb_assert.h"
 #include "regcache.h"
 #include "gdbthread.h"
 #include "gdb_wait.h"
-#include "i386-cpuid.h"
+#include "nat/i386-cpuid.h"
 
 #ifdef HAVE_SYS_SYSCALL_H
 #include <sys/syscall.h>
diff --git a/gdb/common/linux-btrace.h b/gdb/nat/linux-btrace.h
similarity index 100%
rename from gdb/common/linux-btrace.h
rename to gdb/nat/linux-btrace.h
diff --git a/gdb/common/linux-osdata.c b/gdb/nat/linux-osdata.c
similarity index 99%
rename from gdb/common/linux-osdata.c
rename to gdb/nat/linux-osdata.c
index dae637b..1769f30 100644
--- a/gdb/common/linux-osdata.c
+++ b/gdb/nat/linux-osdata.c
@@ -23,7 +23,7 @@
 #include "defs.h"
 #endif
 
-#include "linux-osdata.h"
+#include "nat/linux-osdata.h"
 
 #include <sys/types.h>
 #include <sys/sysinfo.h>
diff --git a/gdb/common/linux-osdata.h b/gdb/nat/linux-osdata.h
similarity index 100%
rename from gdb/common/linux-osdata.h
rename to gdb/nat/linux-osdata.h
diff --git a/gdb/common/linux-procfs.c b/gdb/nat/linux-procfs.c
similarity index 99%
rename from gdb/common/linux-procfs.c
rename to gdb/nat/linux-procfs.c
index 1443a88..fc4bf81 100644
--- a/gdb/common/linux-procfs.c
+++ b/gdb/nat/linux-procfs.c
@@ -23,7 +23,7 @@
 #include <string.h>
 #endif
 
-#include "linux-procfs.h"
+#include "nat/linux-procfs.h"
 #include "filestuff.h"
 
 /* Return the TGID of LWPID from /proc/pid/status.  Returns -1 if not
diff --git a/gdb/common/linux-procfs.h b/gdb/nat/linux-procfs.h
similarity index 100%
rename from gdb/common/linux-procfs.h
rename to gdb/nat/linux-procfs.h
diff --git a/gdb/common/linux-ptrace.c b/gdb/nat/linux-ptrace.c
similarity index 99%
rename from gdb/common/linux-ptrace.c
rename to gdb/nat/linux-ptrace.c
index b140b08..ed5b0d5 100644
--- a/gdb/common/linux-ptrace.c
+++ b/gdb/nat/linux-ptrace.c
@@ -23,8 +23,8 @@
 #include <string.h>
 #endif
 
-#include "linux-ptrace.h"
-#include "linux-procfs.h"
+#include "nat/linux-ptrace.h"
+#include "nat/linux-procfs.h"
 #include "nat/linux-waitpid.h"
 #include "buffer.h"
 #include "gdb_assert.h"
diff --git a/gdb/common/linux-ptrace.h b/gdb/nat/linux-ptrace.h
similarity index 100%
rename from gdb/common/linux-ptrace.h
rename to gdb/nat/linux-ptrace.h
diff --git a/gdb/common/mips-linux-watch.c b/gdb/nat/mips-linux-watch.c
similarity index 99%
rename from gdb/common/mips-linux-watch.c
rename to gdb/nat/mips-linux-watch.c
index acfc7f4..991a128 100644
--- a/gdb/common/mips-linux-watch.c
+++ b/gdb/nat/mips-linux-watch.c
@@ -16,7 +16,7 @@
    along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
 
 #include <sys/ptrace.h>
-#include "mips-linux-watch.h"
+#include "nat/mips-linux-watch.h"
 #include "gdb_assert.h"
 
 /* Assuming usable watch registers REGS, return the irw_mask of
diff --git a/gdb/common/mips-linux-watch.h b/gdb/nat/mips-linux-watch.h
similarity index 100%
rename from gdb/common/mips-linux-watch.h
rename to gdb/nat/mips-linux-watch.h
diff --git a/gdb/testsuite/gdb.arch/i386-avx.c b/gdb/testsuite/gdb.arch/i386-avx.c
index 2fbf1d8..791ead0 100644
--- a/gdb/testsuite/gdb.arch/i386-avx.c
+++ b/gdb/testsuite/gdb.arch/i386-avx.c
@@ -18,7 +18,7 @@
    along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
 
 #include <stdio.h>
-#include "i386-cpuid.h"
+#include "nat/i386-cpuid.h"
 
 typedef struct {
   float f[8];
diff --git a/gdb/testsuite/gdb.arch/i386-avx.exp b/gdb/testsuite/gdb.arch/i386-avx.exp
index 65c0b8f..c310f5e 100644
--- a/gdb/testsuite/gdb.arch/i386-avx.exp
+++ b/gdb/testsuite/gdb.arch/i386-avx.exp
@@ -32,7 +32,7 @@ if [get_compiler_info] {
 
 set additional_flags ""
 if [test_compiler_info gcc*] {
-    set additional_flags "additional_flags=-mavx -I${srcdir}/../common"
+    set additional_flags "additional_flags=-mavx -I${srcdir}/.."
 }
 
 if { [gdb_compile "${srcdir}/${subdir}/${srcfile}" "${binfile}" executable [list debug $additional_flags]] != "" } {
diff --git a/gdb/testsuite/gdb.arch/i386-avx512.c b/gdb/testsuite/gdb.arch/i386-avx512.c
index 0962b07..cb08536 100644
--- a/gdb/testsuite/gdb.arch/i386-avx512.c
+++ b/gdb/testsuite/gdb.arch/i386-avx512.c
@@ -17,7 +17,7 @@
    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
 
-#include "i386-cpuid.h"
+#include "nat/i386-cpuid.h"
 
 typedef struct
 {
diff --git a/gdb/testsuite/gdb.arch/i386-mpx.c b/gdb/testsuite/gdb.arch/i386-mpx.c
index cbc1f4e..4c9fa33 100644
--- a/gdb/testsuite/gdb.arch/i386-mpx.c
+++ b/gdb/testsuite/gdb.arch/i386-mpx.c
@@ -18,7 +18,7 @@
    along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
 
 #include <stdio.h>
-#include "i386-cpuid.h"
+#include "nat/i386-cpuid.h"
 
 #ifndef NOINLINE
 #define NOINLINE __attribute__ ((noinline))
diff --git a/gdb/testsuite/gdb.arch/i386-sse.c b/gdb/testsuite/gdb.arch/i386-sse.c
index 7a07b16..f079980 100644
--- a/gdb/testsuite/gdb.arch/i386-sse.c
+++ b/gdb/testsuite/gdb.arch/i386-sse.c
@@ -18,7 +18,7 @@
    along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
 
 #include <stdio.h>
-#include "i386-cpuid.h"
+#include "nat/i386-cpuid.h"
 
 typedef struct {
   float f[4];
diff --git a/gdb/testsuite/gdb.arch/i386-sse.exp b/gdb/testsuite/gdb.arch/i386-sse.exp
index cc2963b..3b6c475 100644
--- a/gdb/testsuite/gdb.arch/i386-sse.exp
+++ b/gdb/testsuite/gdb.arch/i386-sse.exp
@@ -32,7 +32,7 @@ if [get_compiler_info] {
 
 set additional_flags ""
 if [test_compiler_info gcc*] {
-    set additional_flags "additional_flags=-msse -I${srcdir}/../common"
+    set additional_flags "additional_flags=-msse -I${srcdir}/.."
 }
 
 if { [gdb_compile "${srcdir}/${subdir}/${srcfile}" "${binfile}" executable [list debug $additional_flags]] != "" } {