diff --git a/gdb/ChangeLog b/gdb/ChangeLog
index 2d20b1c..82e3622 100644
--- a/gdb/ChangeLog
+++ b/gdb/ChangeLog
@@ -1,5 +1,10 @@
 2014-09-10  Joel Brobecker  <brobecker@adacore.com>
 
+	* ada-valprint.c (ada_value_print): Use VAL's enclosing type
+	instead of VAL's type.
+
+2014-09-10  Joel Brobecker  <brobecker@adacore.com>
+
 	* amd64-linux-nat.c: Add <sys/uio.h> #include.
 
 2014-09-09  Doug Evans  <xdje42@gmail.com>
diff --git a/gdb/ada-valprint.c b/gdb/ada-valprint.c
index ae07cc2..ade0a65 100644
--- a/gdb/ada-valprint.c
+++ b/gdb/ada-valprint.c
@@ -1171,7 +1171,7 @@ ada_value_print (struct value *val0, struct ui_file *stream,
 {
   struct value *val = ada_to_fixed_value (val0);
   CORE_ADDR address = value_address (val);
-  struct type *type = ada_check_typedef (value_type (val));
+  struct type *type = ada_check_typedef (value_enclosing_type (val));
   struct value_print_options opts;
 
   /* If it is a pointer, indicate what it points to.  */
diff --git a/gdb/testsuite/ChangeLog b/gdb/testsuite/ChangeLog
index 37fe6a1..e7bba77 100644
--- a/gdb/testsuite/ChangeLog
+++ b/gdb/testsuite/ChangeLog
@@ -1,3 +1,8 @@
+2014-09-10  Joel Brobecker  <brobecker@adacore.com>
+
+	* gdb.dwarf2/dynarr-ptr.c: New file.
+	* gdb.dwarf2/dynarr-ptr.exp: New file.
+
 2014-09-09  Maciej W. Rozycki  <macro@codesourcery.com>
 
 	* gdb.base/watchpoint-solib.exp: Increase the timeout by a factor
diff --git a/gdb/testsuite/gdb.dwarf2/dynarr-ptr.c b/gdb/testsuite/gdb.dwarf2/dynarr-ptr.c
new file mode 100644
index 0000000..2bdf254
--- /dev/null
+++ b/gdb/testsuite/gdb.dwarf2/dynarr-ptr.c
@@ -0,0 +1,30 @@
+/* Copyright 2014 Free Software Foundation, Inc.
+
+   This file is part of GDB.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
+
+int table_1_data[] = {1, 3, 1, 2, 3};
+int *table_1_ptr = &table_1_data[2];
+
+int table_2_data[] = {2, 6, 5, 8, 13, 21, 34};
+int *table_2_ptr = &table_2_data[2];
+
+int
+main (void)
+{
+  *table_1_ptr = 2;
+  *table_2_ptr = 3;
+  return 0;
+}
diff --git a/gdb/testsuite/gdb.dwarf2/dynarr-ptr.exp b/gdb/testsuite/gdb.dwarf2/dynarr-ptr.exp
new file mode 100644
index 0000000..501f129
--- /dev/null
+++ b/gdb/testsuite/gdb.dwarf2/dynarr-ptr.exp
@@ -0,0 +1,153 @@
+# Copyright 2014 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+load_lib dwarf.exp
+
+# This test can only be run on targets which support DWARF-2 and use gas.
+if {![dwarf2_support]} {
+    return 0
+}
+
+standard_testfile dynarr-ptr.c dynarr-ptr-dw.S
+
+# We need to know the size of integer and address types in order
+# to write some of the debugging info we'd like to generate.
+#
+# For that, we ask GDB by debugging our dynarr-ptr.c program.
+# Any program would do, but since we already have dynarr-ptr.c
+# specifically for this testcase, might as well use that.
+
+if { [prepare_for_testing ${testfile}.exp ${testfile} ${srcfile}] } {
+    untested ${testfile}.exp
+    return -1
+}
+
+# Make some DWARF for the test.
+set asm_file [standard_output_file $srcfile2]
+Dwarf::assemble $asm_file {
+    cu {} {
+ 	DW_TAG_compile_unit {
+                {DW_AT_language @DW_LANG_Ada95}
+                {DW_AT_name     foo.adb}
+                {DW_AT_comp_dir /tmp}
+        } {
+            declare_labels integer_label array_label array_ptr_label \
+                array_typedef_label
+            set ptr_size [get_sizeof "void *" 96]
+
+            integer_label: DW_TAG_base_type {
+                {DW_AT_byte_size 4 DW_FORM_sdata}
+                {DW_AT_encoding  @DW_ATE_signed}
+                {DW_AT_name      integer}
+            }
+
+	    array_label: DW_TAG_array_type {
+		{DW_AT_name foo__array_type}
+		{DW_AT_type :$integer_label}
+                {external 1 flag}
+	    } {
+		DW_TAG_subrange_type {
+		    {DW_AT_type        :$integer_label}
+                    {DW_AT_lower_bound {
+                        DW_OP_push_object_address
+                        DW_OP_lit8
+                        DW_OP_minus
+                        DW_OP_deref_size 4
+                    } SPECIAL_expr}
+                    {DW_AT_upper_bound {
+                        DW_OP_push_object_address
+                        DW_OP_lit4
+                        DW_OP_minus
+                        DW_OP_deref_size 4
+                    } SPECIAL_expr}
+		}
+	    }
+            array_ptr_label: DW_TAG_pointer_type {
+                {DW_AT_byte_size :$ptr_size }
+                {DW_AT_type :$array_label}
+            }
+            array_typedef_label: DW_TAG_typedef {
+                {DW_AT_name "foo__array_ptr"}
+                {DW_AT_type :$array_ptr_label}
+            }
+            DW_TAG_variable {
+                {DW_AT_name foo__three_ptr}
+                {DW_AT_type :$array_ptr_label}
+                {DW_AT_location {
+                    DW_OP_addr table_1_ptr
+                } SPECIAL_expr}
+                {external 1 flag}
+            }
+            DW_TAG_variable {
+                {DW_AT_name foo__three_ptr_tdef}
+                {DW_AT_type :$array_typedef_label}
+                {DW_AT_location {
+                    DW_OP_addr table_1_ptr
+                } SPECIAL_expr}
+                {external 1 flag}
+            }
+            DW_TAG_variable {
+                {DW_AT_name foo__five_ptr}
+                {DW_AT_type :$array_ptr_label}
+                {DW_AT_location {
+                    DW_OP_addr table_2_ptr
+                } SPECIAL_expr}
+                {external 1 flag}
+            }
+            DW_TAG_variable {
+                {DW_AT_name foo__five_ptr_tdef}
+                {DW_AT_type :$array_typedef_label}
+                {DW_AT_location {
+                    DW_OP_addr table_2_ptr
+                } SPECIAL_expr}
+                {external 1 flag}
+            }
+	}
+    }
+}
+
+# Now that we've generated the DWARF debugging info, rebuild our
+# program using our debug info instead of the info generated by
+# the compiler.
+
+if { [prepare_for_testing ${testfile}.exp ${testfile} \
+	  [list $srcfile $asm_file] {nodebug}] } {
+    return -1
+}
+
+if ![runto_main] {
+    return -1
+}
+
+gdb_test_no_output "set language ada"
+
+# foo.three_ptr.all
+
+gdb_test "print foo.three_ptr.all" \
+         " = \\(1, 2, 3\\)"
+
+# foo.three_ptr_tdef.all
+
+gdb_test "print foo.three_ptr_tdef.all" \
+         " = \\(1, 2, 3\\)"
+
+# foo.five_ptr.all
+
+gdb_test "print foo.five_ptr.all" \
+         " = \\(2 => 5, 8, 13, 21, 34\\)"
+
+# foo.five_ptr_tdef.all
+
+gdb_test "print foo.five_ptr_tdef.all" \
+         " = \\(2 => 5, 8, 13, 21, 34\\)"